/*
 * BluSunrize
 * Copyright (c) 2017
 *
 * This code is licensed under "Blu's License of Common Sense"
 * Details can be found in the license file in the root folder of this project
 */

package blusunrize.immersiveengineering.common.util.compat;

import blusunrize.immersiveengineering.api.tool.ChemthrowerHandler;
import blusunrize.immersiveengineering.api.tool.ChemthrowerHandler.ChemthrowerEffect_Potion;
import blusunrize.immersiveengineering.api.tool.ConveyorHandler;
import blusunrize.immersiveengineering.api.tool.ConveyorHandler.IConveyorTile;
import blusunrize.immersiveengineering.common.IERecipes;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.init.MobEffects;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.potion.PotionEffect;
import net.minecraft.tileentity.TileEntity;

import java.util.function.BiConsumer;

/**
 * @author BluSunrize - 22.08.2016
 */
public class EnderIOHelper extends IECompatModule
{
	public static final String EIO_MAGNET_NBT = "EIOpuller";

	@Override
	public void preInit()
	{
	}

	@Override
	public void init()
	{
		IERecipes.addOreDictArcAlloyingRecipe("ingotElectricalSteel", 1, "Iron", 400, 512, "dustCoal", "itemSilicon");
		IERecipes.addOreDictArcAlloyingRecipe("ingotEnergeticAlloy", 1, "Gold", 200, 512, "dustRedstone", "dustGlowstone");
		IERecipes.addOreDictArcAlloyingRecipe("ingotPhaseGold", 1, "EnergeticAlloy", 200, 512, Items.field_151079_bi);
		IERecipes.addOreDictArcAlloyingRecipe("ingotPhasedIron", 1, "Iron", 200, 512, Items.field_151079_bi);
		IERecipes.addOreDictArcAlloyingRecipe("ingotConductiveIron", 1, "Iron", 100, 512, "dustRedstone");
		IERecipes.addOreDictArcAlloyingRecipe("ingotDarkSteel", 1, "Iron", 400, 512, "dustCoal", "obsidian");
		IERecipes.addOreDictArcAlloyingRecipe("ingotSoularium", 1, "Gold", 200, 512, Blocks.field_150425_aM);

		ChemthrowerHandler.registerEffect("nutrient_distillation", new ChemthrowerEffect_Potion(null, 0, MobEffects.field_76431_k, 80, 1));
		ChemthrowerHandler.registerEffect("liquid_sunshine", new ChemthrowerEffect_Potion(null, 0, new PotionEffect(MobEffects.field_188423_x, 200, 0),new PotionEffect(MobEffects.field_188424_y, 40, 0)));
		ChemthrowerHandler.registerEffect("cloud_seed_concentrated", new ChemthrowerEffect_Potion(null, 0, MobEffects.field_76440_q, 40, 0));
		ChemthrowerHandler.registerEffect("vapor_of_levity", new ChemthrowerEffect_Potion(null, 0, MobEffects.field_188424_y, 80, 2));

		ConveyorHandler.registerMagnetSupression(new BiConsumer<Entity, IConveyorTile>()
		{
			@Override
			public void accept(Entity entity, IConveyorTile iConveyorTile)
			{
				if(entity instanceof EntityItem)
				{
					NBTTagCompound data = entity.getEntityData();
					long pos = ((TileEntity) iConveyorTile).func_174877_v().func_177986_g();
					if(!data.func_74764_b(EIO_MAGNET_NBT) || data.func_74763_f(EIO_MAGNET_NBT) != pos)
						data.func_74772_a(EIO_MAGNET_NBT, pos);
				}
			}
		}, new BiConsumer<Entity, IConveyorTile>()
		{
			@Override
			public void accept(Entity entity, IConveyorTile iConveyorTile)
			{
				if(entity instanceof EntityItem)
					entity.getEntityData().func_82580_o(EIO_MAGNET_NBT);
			}
		});
	}

	@Override
	public void postInit()
	{
	}
}
